"""
    MI Server API

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import (
    TYPE_CHECKING,
    Any,
    Dict,
    List,
    BinaryIO,
    Optional,
    Union,
)  # noqa: F401

from . import ModelBase
from ansys.grantami.serverapi_openapi.models.granta_server_api_aggregations_aggregation_criterion import (
    GrantaServerApiAggregationsAggregationCriterion,
)  # noqa: F401


if TYPE_CHECKING:
    from datetime import datetime
    import pathlib
    from . import *


class GrantaServerApiAggregationsFreeTextAggregationCriterion(
    GrantaServerApiAggregationsAggregationCriterion
):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: Dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: Dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: Dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: Dict[str, str] = {
        "attributes": "GrantaServerApiValueSpecifier",
        "criterion_guid": "str",
        "local_columns": "GrantaServerApiValueSpecifier",
        "number_of_terms": "int",
        "prefix": "str",
        "type": "str",
    }

    attribute_map: Dict[str, str] = {
        "attributes": "attributes",
        "criterion_guid": "criterionGuid",
        "local_columns": "localColumns",
        "number_of_terms": "numberOfTerms",
        "prefix": "prefix",
        "type": "type",
    }

    subtype_mapping: Dict[str, str] = {
        "attributes": "GrantaServerApiValueSpecifier",
        "localColumns": "GrantaServerApiValueSpecifier",
    }

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        attributes: "Optional[GrantaServerApiValueSpecifier]" = None,
        criterion_guid: "Optional[str]" = None,
        local_columns: "Optional[GrantaServerApiValueSpecifier]" = None,
        number_of_terms: "Optional[int]" = None,
        prefix: "Optional[str]" = None,
        type: "str" = "text",
    ) -> None:
        """GrantaServerApiAggregationsFreeTextAggregationCriterion - a model defined in Swagger

        Parameters
        ----------
            attributes: GrantaServerApiValueSpecifier, optional
            criterion_guid: str, optional
            local_columns: GrantaServerApiValueSpecifier, optional
            number_of_terms: int, optional
            prefix: str, optional
            type: str
        """
        super().__init__()
        self._criterion_guid = None
        self._number_of_terms = None
        self._prefix = None
        self._attributes = None
        self._local_columns = None
        self._type: str = None  # type: ignore[assignment]

        if criterion_guid is not None:
            self.criterion_guid = criterion_guid
        if number_of_terms is not None:
            self.number_of_terms = number_of_terms
        if prefix is not None:
            self.prefix = prefix
        if attributes is not None:
            self.attributes = attributes
        if local_columns is not None:
            self.local_columns = local_columns
        self.type = type

    @property
    def criterion_guid(self) -> "Optional[str]":
        """Gets the criterion_guid of this GrantaServerApiAggregationsFreeTextAggregationCriterion.
        A GUID to identify this free-text criterion, so that its results can be determined in the output.  For each input free-text aggregation criterion, there will be a free-text aggregation in the output  with a matching GUID.

        Returns
        -------
        str
            The criterion_guid of this GrantaServerApiAggregationsFreeTextAggregationCriterion.
        """
        return self._criterion_guid

    @criterion_guid.setter
    def criterion_guid(self, criterion_guid: "Optional[str]") -> None:
        """Sets the criterion_guid of this GrantaServerApiAggregationsFreeTextAggregationCriterion.
        A GUID to identify this free-text criterion, so that its results can be determined in the output.  For each input free-text aggregation criterion, there will be a free-text aggregation in the output  with a matching GUID.

        Parameters
        ----------
        criterion_guid: str
            The criterion_guid of this GrantaServerApiAggregationsFreeTextAggregationCriterion.
        """
        self._criterion_guid = criterion_guid

    @property
    def number_of_terms(self) -> "Optional[int]":
        """Gets the number_of_terms of this GrantaServerApiAggregationsFreeTextAggregationCriterion.
        The number of terms that should be returned

        Returns
        -------
        int
            The number_of_terms of this GrantaServerApiAggregationsFreeTextAggregationCriterion.
        """
        return self._number_of_terms

    @number_of_terms.setter
    def number_of_terms(self, number_of_terms: "Optional[int]") -> None:
        """Sets the number_of_terms of this GrantaServerApiAggregationsFreeTextAggregationCriterion.
        The number of terms that should be returned

        Parameters
        ----------
        number_of_terms: int
            The number_of_terms of this GrantaServerApiAggregationsFreeTextAggregationCriterion.
        """
        self._number_of_terms = number_of_terms

    @property
    def prefix(self) -> "Optional[str]":
        """Gets the prefix of this GrantaServerApiAggregationsFreeTextAggregationCriterion.

        Returns
        -------
        str
            The prefix of this GrantaServerApiAggregationsFreeTextAggregationCriterion.
        """
        return self._prefix

    @prefix.setter
    def prefix(self, prefix: "Optional[str]") -> None:
        """Sets the prefix of this GrantaServerApiAggregationsFreeTextAggregationCriterion.

        Parameters
        ----------
        prefix: str
            The prefix of this GrantaServerApiAggregationsFreeTextAggregationCriterion.
        """
        self._prefix = prefix

    @property
    def attributes(self) -> "Optional[GrantaServerApiValueSpecifier]":
        """Gets the attributes of this GrantaServerApiAggregationsFreeTextAggregationCriterion.

        Returns
        -------
        GrantaServerApiValueSpecifier
            The attributes of this GrantaServerApiAggregationsFreeTextAggregationCriterion.
        """
        return self._attributes

    @attributes.setter
    def attributes(self, attributes: "Optional[GrantaServerApiValueSpecifier]") -> None:
        """Sets the attributes of this GrantaServerApiAggregationsFreeTextAggregationCriterion.

        Parameters
        ----------
        attributes: GrantaServerApiValueSpecifier
            The attributes of this GrantaServerApiAggregationsFreeTextAggregationCriterion.
        """
        self._attributes = attributes

    @property
    def local_columns(self) -> "Optional[GrantaServerApiValueSpecifier]":
        """Gets the local_columns of this GrantaServerApiAggregationsFreeTextAggregationCriterion.

        Returns
        -------
        GrantaServerApiValueSpecifier
            The local_columns of this GrantaServerApiAggregationsFreeTextAggregationCriterion.
        """
        return self._local_columns

    @local_columns.setter
    def local_columns(
        self, local_columns: "Optional[GrantaServerApiValueSpecifier]"
    ) -> None:
        """Sets the local_columns of this GrantaServerApiAggregationsFreeTextAggregationCriterion.

        Parameters
        ----------
        local_columns: GrantaServerApiValueSpecifier
            The local_columns of this GrantaServerApiAggregationsFreeTextAggregationCriterion.
        """
        self._local_columns = local_columns

    @property
    def type(self) -> "str":
        """Gets the type of this GrantaServerApiAggregationsFreeTextAggregationCriterion.

        Returns
        -------
        str
            The type of this GrantaServerApiAggregationsFreeTextAggregationCriterion.
        """
        return self._type

    @type.setter
    def type(self, type: "str") -> None:
        """Sets the type of this GrantaServerApiAggregationsFreeTextAggregationCriterion.

        Parameters
        ----------
        type: str
            The type of this GrantaServerApiAggregationsFreeTextAggregationCriterion.
        """
        if type is None:
            raise ValueError("Invalid value for 'type', must not be 'None'")
        self._type = type

    @classmethod
    def get_real_child_model(cls, data: ModelBase) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()  # type: ignore[no-any-return]

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(
            other, GrantaServerApiAggregationsFreeTextAggregationCriterion
        ):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
