"""
    MI Server API

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import (
    TYPE_CHECKING,
    Any,
    Dict,
    List,
    BinaryIO,
    Optional,
    Union,
)  # noqa: F401

from . import ModelBase
from ansys.grantami.serverapi_openapi.models.granta_server_api_data_applicable_datum import (
    GrantaServerApiDataApplicableDatum,
)  # noqa: F401


if TYPE_CHECKING:
    from datetime import datetime
    import pathlib
    from . import *


class GrantaServerApiDataRangeDatum(GrantaServerApiDataApplicableDatum):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: Dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: Dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: Dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: Dict[str, str] = {
        "estimated": "bool",
        "high_value": "float",
        "high_value_is_inclusive": "bool",
        "low_value": "float",
        "low_value_is_inclusive": "bool",
        "datum_type": "str",
        "high_value_significant_figures_info": "GrantaServerApiDataSignificantFiguresInfo",
        "low_value_significant_figures_info": "GrantaServerApiDataSignificantFiguresInfo",
        "not_applicable": "str",
        "unit": "GrantaServerApiSchemaSlimEntitiesSlimUnit",
    }

    attribute_map: Dict[str, str] = {
        "estimated": "estimated",
        "high_value": "highValue",
        "high_value_is_inclusive": "highValueIsInclusive",
        "low_value": "lowValue",
        "low_value_is_inclusive": "lowValueIsInclusive",
        "datum_type": "datumType",
        "high_value_significant_figures_info": "highValueSignificantFiguresInfo",
        "low_value_significant_figures_info": "lowValueSignificantFiguresInfo",
        "not_applicable": "notApplicable",
        "unit": "unit",
    }

    subtype_mapping: Dict[str, str] = {
        "lowValueSignificantFiguresInfo": "GrantaServerApiDataSignificantFiguresInfo",
        "highValueSignificantFiguresInfo": "GrantaServerApiDataSignificantFiguresInfo",
        "unit": "GrantaServerApiSchemaSlimEntitiesSlimUnit",
    }

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        estimated: "bool",
        high_value: "float",
        high_value_is_inclusive: "bool",
        low_value: "float",
        low_value_is_inclusive: "bool",
        datum_type: "str" = "range",
        high_value_significant_figures_info: "Optional[GrantaServerApiDataSignificantFiguresInfo]" = None,
        low_value_significant_figures_info: "Optional[GrantaServerApiDataSignificantFiguresInfo]" = None,
        not_applicable: "str" = "applicable",
        unit: "Optional[GrantaServerApiSchemaSlimEntitiesSlimUnit]" = None,
    ) -> None:
        """GrantaServerApiDataRangeDatum - a model defined in Swagger

        Parameters
        ----------
            estimated: bool
            high_value: float
            high_value_is_inclusive: bool
            low_value: float
            low_value_is_inclusive: bool
            datum_type: str
            high_value_significant_figures_info: GrantaServerApiDataSignificantFiguresInfo, optional
            low_value_significant_figures_info: GrantaServerApiDataSignificantFiguresInfo, optional
            not_applicable: str
            unit: GrantaServerApiSchemaSlimEntitiesSlimUnit, optional
        """
        super().__init__(not_applicable=not_applicable)
        self._datum_type: str = None  # type: ignore[assignment]
        self._low_value: float = None  # type: ignore[assignment]
        self._high_value: float = None  # type: ignore[assignment]
        self._low_value_is_inclusive: bool = None  # type: ignore[assignment]
        self._high_value_is_inclusive: bool = None  # type: ignore[assignment]
        self._low_value_significant_figures_info = None
        self._high_value_significant_figures_info = None
        self._estimated: bool = None  # type: ignore[assignment]
        self._unit = None

        self.datum_type = datum_type
        self.low_value = low_value
        self.high_value = high_value
        self.low_value_is_inclusive = low_value_is_inclusive
        self.high_value_is_inclusive = high_value_is_inclusive
        if low_value_significant_figures_info is not None:
            self.low_value_significant_figures_info = low_value_significant_figures_info
        if high_value_significant_figures_info is not None:
            self.high_value_significant_figures_info = (
                high_value_significant_figures_info
            )
        self.estimated = estimated
        if unit is not None:
            self.unit = unit

    @property
    def datum_type(self) -> "str":
        """Gets the datum_type of this GrantaServerApiDataRangeDatum.

        Returns
        -------
        str
            The datum_type of this GrantaServerApiDataRangeDatum.
        """
        return self._datum_type

    @datum_type.setter
    def datum_type(self, datum_type: "str") -> None:
        """Sets the datum_type of this GrantaServerApiDataRangeDatum.

        Parameters
        ----------
        datum_type: str
            The datum_type of this GrantaServerApiDataRangeDatum.
        """
        if datum_type is None:
            raise ValueError("Invalid value for 'datum_type', must not be 'None'")
        self._datum_type = datum_type

    @property
    def low_value(self) -> "float":
        """Gets the low_value of this GrantaServerApiDataRangeDatum.

        Returns
        -------
        float
            The low_value of this GrantaServerApiDataRangeDatum.
        """
        return self._low_value

    @low_value.setter
    def low_value(self, low_value: "float") -> None:
        """Sets the low_value of this GrantaServerApiDataRangeDatum.

        Parameters
        ----------
        low_value: float
            The low_value of this GrantaServerApiDataRangeDatum.
        """
        if low_value is None:
            raise ValueError("Invalid value for 'low_value', must not be 'None'")
        self._low_value = low_value

    @property
    def high_value(self) -> "float":
        """Gets the high_value of this GrantaServerApiDataRangeDatum.

        Returns
        -------
        float
            The high_value of this GrantaServerApiDataRangeDatum.
        """
        return self._high_value

    @high_value.setter
    def high_value(self, high_value: "float") -> None:
        """Sets the high_value of this GrantaServerApiDataRangeDatum.

        Parameters
        ----------
        high_value: float
            The high_value of this GrantaServerApiDataRangeDatum.
        """
        if high_value is None:
            raise ValueError("Invalid value for 'high_value', must not be 'None'")
        self._high_value = high_value

    @property
    def low_value_is_inclusive(self) -> "bool":
        """Gets the low_value_is_inclusive of this GrantaServerApiDataRangeDatum.

        Returns
        -------
        bool
            The low_value_is_inclusive of this GrantaServerApiDataRangeDatum.
        """
        return self._low_value_is_inclusive

    @low_value_is_inclusive.setter
    def low_value_is_inclusive(self, low_value_is_inclusive: "bool") -> None:
        """Sets the low_value_is_inclusive of this GrantaServerApiDataRangeDatum.

        Parameters
        ----------
        low_value_is_inclusive: bool
            The low_value_is_inclusive of this GrantaServerApiDataRangeDatum.
        """
        if low_value_is_inclusive is None:
            raise ValueError(
                "Invalid value for 'low_value_is_inclusive', must not be 'None'"
            )
        self._low_value_is_inclusive = low_value_is_inclusive

    @property
    def high_value_is_inclusive(self) -> "bool":
        """Gets the high_value_is_inclusive of this GrantaServerApiDataRangeDatum.

        Returns
        -------
        bool
            The high_value_is_inclusive of this GrantaServerApiDataRangeDatum.
        """
        return self._high_value_is_inclusive

    @high_value_is_inclusive.setter
    def high_value_is_inclusive(self, high_value_is_inclusive: "bool") -> None:
        """Sets the high_value_is_inclusive of this GrantaServerApiDataRangeDatum.

        Parameters
        ----------
        high_value_is_inclusive: bool
            The high_value_is_inclusive of this GrantaServerApiDataRangeDatum.
        """
        if high_value_is_inclusive is None:
            raise ValueError(
                "Invalid value for 'high_value_is_inclusive', must not be 'None'"
            )
        self._high_value_is_inclusive = high_value_is_inclusive

    @property
    def low_value_significant_figures_info(
        self,
    ) -> "Optional[GrantaServerApiDataSignificantFiguresInfo]":
        """Gets the low_value_significant_figures_info of this GrantaServerApiDataRangeDatum.

        Returns
        -------
        GrantaServerApiDataSignificantFiguresInfo
            The low_value_significant_figures_info of this GrantaServerApiDataRangeDatum.
        """
        return self._low_value_significant_figures_info

    @low_value_significant_figures_info.setter
    def low_value_significant_figures_info(
        self,
        low_value_significant_figures_info: "Optional[GrantaServerApiDataSignificantFiguresInfo]",
    ) -> None:
        """Sets the low_value_significant_figures_info of this GrantaServerApiDataRangeDatum.

        Parameters
        ----------
        low_value_significant_figures_info: GrantaServerApiDataSignificantFiguresInfo
            The low_value_significant_figures_info of this GrantaServerApiDataRangeDatum.
        """
        self._low_value_significant_figures_info = low_value_significant_figures_info

    @property
    def high_value_significant_figures_info(
        self,
    ) -> "Optional[GrantaServerApiDataSignificantFiguresInfo]":
        """Gets the high_value_significant_figures_info of this GrantaServerApiDataRangeDatum.

        Returns
        -------
        GrantaServerApiDataSignificantFiguresInfo
            The high_value_significant_figures_info of this GrantaServerApiDataRangeDatum.
        """
        return self._high_value_significant_figures_info

    @high_value_significant_figures_info.setter
    def high_value_significant_figures_info(
        self,
        high_value_significant_figures_info: "Optional[GrantaServerApiDataSignificantFiguresInfo]",
    ) -> None:
        """Sets the high_value_significant_figures_info of this GrantaServerApiDataRangeDatum.

        Parameters
        ----------
        high_value_significant_figures_info: GrantaServerApiDataSignificantFiguresInfo
            The high_value_significant_figures_info of this GrantaServerApiDataRangeDatum.
        """
        self._high_value_significant_figures_info = high_value_significant_figures_info

    @property
    def estimated(self) -> "bool":
        """Gets the estimated of this GrantaServerApiDataRangeDatum.

        Returns
        -------
        bool
            The estimated of this GrantaServerApiDataRangeDatum.
        """
        return self._estimated

    @estimated.setter
    def estimated(self, estimated: "bool") -> None:
        """Sets the estimated of this GrantaServerApiDataRangeDatum.

        Parameters
        ----------
        estimated: bool
            The estimated of this GrantaServerApiDataRangeDatum.
        """
        if estimated is None:
            raise ValueError("Invalid value for 'estimated', must not be 'None'")
        self._estimated = estimated

    @property
    def unit(self) -> "Optional[GrantaServerApiSchemaSlimEntitiesSlimUnit]":
        """Gets the unit of this GrantaServerApiDataRangeDatum.

        Returns
        -------
        GrantaServerApiSchemaSlimEntitiesSlimUnit
            The unit of this GrantaServerApiDataRangeDatum.
        """
        return self._unit

    @unit.setter
    def unit(self, unit: "Optional[GrantaServerApiSchemaSlimEntitiesSlimUnit]") -> None:
        """Sets the unit of this GrantaServerApiDataRangeDatum.

        Parameters
        ----------
        unit: GrantaServerApiSchemaSlimEntitiesSlimUnit
            The unit of this GrantaServerApiDataRangeDatum.
        """
        self._unit = unit

    @classmethod
    def get_real_child_model(cls, data: ModelBase) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()  # type: ignore[no-any-return]

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, GrantaServerApiDataRangeDatum):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
