"""
    MI Server API

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import (
    TYPE_CHECKING,
    Any,
    Dict,
    List,
    BinaryIO,
    Optional,
    Union,
)  # noqa: F401

from . import ModelBase
from ansys.grantami.serverapi_openapi.models.granta_server_api_search_datum_criterion import (
    GrantaServerApiSearchDatumCriterion,
)  # noqa: F401


if TYPE_CHECKING:
    from datetime import datetime
    import pathlib
    from . import *


class GrantaServerApiSearchLinkDatumCriterion(GrantaServerApiSearchDatumCriterion):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: Dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: Dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: Dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: Dict[str, str] = {
        "indirect_links": "GrantaServerApiIndirectLinks",
        "inner_criterion": "GrantaServerApiSearchCriterion",
        "link_datum_type": "GrantaServerApiLinkAttributeType",
        "local_criterion": "GrantaServerApiSearchCriterion",
        "local_rows_behaviour": "GrantaServerApiSearchLocalRowsBehaviour",
        "search_in_reversed_direction": "bool",
        "target_attribute_guid": "str",
        "target_attribute_identity": "int",
        "target_database_key": "str",
        "target_table_guid": "str",
        "target_table_identity": "int",
        "type": "str",
    }

    attribute_map: Dict[str, str] = {
        "indirect_links": "indirectLinks",
        "inner_criterion": "innerCriterion",
        "link_datum_type": "linkDatumType",
        "local_criterion": "localCriterion",
        "local_rows_behaviour": "localRowsBehaviour",
        "search_in_reversed_direction": "searchInReversedDirection",
        "target_attribute_guid": "targetAttributeGuid",
        "target_attribute_identity": "targetAttributeIdentity",
        "target_database_key": "targetDatabaseKey",
        "target_table_guid": "targetTableGuid",
        "target_table_identity": "targetTableIdentity",
        "type": "type",
    }

    subtype_mapping: Dict[str, str] = {
        "localCriterion": "GrantaServerApiSearchCriterion",
        "linkDatumType": "GrantaServerApiLinkAttributeType",
        "indirectLinks": "GrantaServerApiIndirectLinks",
        "innerCriterion": "GrantaServerApiSearchCriterion",
        "localRowsBehaviour": "GrantaServerApiSearchLocalRowsBehaviour",
    }

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        indirect_links: "Optional[GrantaServerApiIndirectLinks]" = None,
        inner_criterion: "Optional[GrantaServerApiSearchCriterion]" = None,
        link_datum_type: "Optional[GrantaServerApiLinkAttributeType]" = None,
        local_criterion: "Optional[GrantaServerApiSearchCriterion]" = None,
        local_rows_behaviour: "Optional[GrantaServerApiSearchLocalRowsBehaviour]" = None,
        search_in_reversed_direction: "Optional[bool]" = None,
        target_attribute_guid: "Optional[str]" = None,
        target_attribute_identity: "Optional[int]" = None,
        target_database_key: "Optional[str]" = None,
        target_table_guid: "Optional[str]" = None,
        target_table_identity: "Optional[int]" = None,
        type: "str" = "link",
    ) -> None:
        """GrantaServerApiSearchLinkDatumCriterion - a model defined in Swagger

        Parameters
        ----------
            indirect_links: GrantaServerApiIndirectLinks, optional
            inner_criterion: GrantaServerApiSearchCriterion, optional
            link_datum_type: GrantaServerApiLinkAttributeType, optional
            local_criterion: GrantaServerApiSearchCriterion, optional
            local_rows_behaviour: GrantaServerApiSearchLocalRowsBehaviour, optional
            search_in_reversed_direction: bool, optional
            target_attribute_guid: str, optional
            target_attribute_identity: int, optional
            target_database_key: str, optional
            target_table_guid: str, optional
            target_table_identity: int, optional
            type: str
        """
        super().__init__()
        self._target_table_identity = None
        self._target_table_guid = None
        self._target_database_key = None
        self._local_criterion = None
        self._link_datum_type = None
        self._indirect_links = None
        self._search_in_reversed_direction = None
        self._target_attribute_identity = None
        self._target_attribute_guid = None
        self._inner_criterion = None
        self._type: str = None  # type: ignore[assignment]
        self._local_rows_behaviour = None

        if target_table_identity is not None:
            self.target_table_identity = target_table_identity
        if target_table_guid is not None:
            self.target_table_guid = target_table_guid
        if target_database_key is not None:
            self.target_database_key = target_database_key
        if local_criterion is not None:
            self.local_criterion = local_criterion
        if link_datum_type is not None:
            self.link_datum_type = link_datum_type
        if indirect_links is not None:
            self.indirect_links = indirect_links
        if search_in_reversed_direction is not None:
            self.search_in_reversed_direction = search_in_reversed_direction
        if target_attribute_identity is not None:
            self.target_attribute_identity = target_attribute_identity
        if target_attribute_guid is not None:
            self.target_attribute_guid = target_attribute_guid
        if inner_criterion is not None:
            self.inner_criterion = inner_criterion
        self.type = type
        if local_rows_behaviour is not None:
            self.local_rows_behaviour = local_rows_behaviour

    @property
    def target_table_identity(self) -> "Optional[int]":
        """Gets the target_table_identity of this GrantaServerApiSearchLinkDatumCriterion.
        Table containing the linked records.  The target table can be omitted; it is likely to improve performance if it is included.  For tabular search, if either the target attribute or the target table is provided, they should both be provided.

        Returns
        -------
        int
            The target_table_identity of this GrantaServerApiSearchLinkDatumCriterion.
        """
        return self._target_table_identity

    @target_table_identity.setter
    def target_table_identity(self, target_table_identity: "Optional[int]") -> None:
        """Sets the target_table_identity of this GrantaServerApiSearchLinkDatumCriterion.
        Table containing the linked records.  The target table can be omitted; it is likely to improve performance if it is included.  For tabular search, if either the target attribute or the target table is provided, they should both be provided.

        Parameters
        ----------
        target_table_identity: int
            The target_table_identity of this GrantaServerApiSearchLinkDatumCriterion.
        """
        self._target_table_identity = target_table_identity

    @property
    def target_table_guid(self) -> "Optional[str]":
        """Gets the target_table_guid of this GrantaServerApiSearchLinkDatumCriterion.
        Table containing the linked records.  The target table can be omitted; it is likely to improve performance if it is included.  For tabular search, if either the target attribute or the target table is provided, they should both be provided.

        Returns
        -------
        str
            The target_table_guid of this GrantaServerApiSearchLinkDatumCriterion.
        """
        return self._target_table_guid

    @target_table_guid.setter
    def target_table_guid(self, target_table_guid: "Optional[str]") -> None:
        """Sets the target_table_guid of this GrantaServerApiSearchLinkDatumCriterion.
        Table containing the linked records.  The target table can be omitted; it is likely to improve performance if it is included.  For tabular search, if either the target attribute or the target table is provided, they should both be provided.

        Parameters
        ----------
        target_table_guid: str
            The target_table_guid of this GrantaServerApiSearchLinkDatumCriterion.
        """
        self._target_table_guid = target_table_guid

    @property
    def target_database_key(self) -> "Optional[str]":
        """Gets the target_database_key of this GrantaServerApiSearchLinkDatumCriterion.
        Database containing the linked records. For reverse cross database links, this is the database where the link is defined

        Returns
        -------
        str
            The target_database_key of this GrantaServerApiSearchLinkDatumCriterion.
        """
        return self._target_database_key

    @target_database_key.setter
    def target_database_key(self, target_database_key: "Optional[str]") -> None:
        """Sets the target_database_key of this GrantaServerApiSearchLinkDatumCriterion.
        Database containing the linked records. For reverse cross database links, this is the database where the link is defined

        Parameters
        ----------
        target_database_key: str
            The target_database_key of this GrantaServerApiSearchLinkDatumCriterion.
        """
        self._target_database_key = target_database_key

    @property
    def local_criterion(self) -> "Optional[GrantaServerApiSearchCriterion]":
        """Gets the local_criterion of this GrantaServerApiSearchLinkDatumCriterion.

        Returns
        -------
        GrantaServerApiSearchCriterion
            The local_criterion of this GrantaServerApiSearchLinkDatumCriterion.
        """
        return self._local_criterion

    @local_criterion.setter
    def local_criterion(
        self, local_criterion: "Optional[GrantaServerApiSearchCriterion]"
    ) -> None:
        """Sets the local_criterion of this GrantaServerApiSearchLinkDatumCriterion.

        Parameters
        ----------
        local_criterion: GrantaServerApiSearchCriterion
            The local_criterion of this GrantaServerApiSearchLinkDatumCriterion.
        """
        self._local_criterion = local_criterion

    @property
    def link_datum_type(self) -> "Optional[GrantaServerApiLinkAttributeType]":
        """Gets the link_datum_type of this GrantaServerApiSearchLinkDatumCriterion.

        Returns
        -------
        GrantaServerApiLinkAttributeType
            The link_datum_type of this GrantaServerApiSearchLinkDatumCriterion.
        """
        return self._link_datum_type

    @link_datum_type.setter
    def link_datum_type(
        self, link_datum_type: "Optional[GrantaServerApiLinkAttributeType]"
    ) -> None:
        """Sets the link_datum_type of this GrantaServerApiSearchLinkDatumCriterion.

        Parameters
        ----------
        link_datum_type: GrantaServerApiLinkAttributeType
            The link_datum_type of this GrantaServerApiSearchLinkDatumCriterion.
        """
        self._link_datum_type = link_datum_type

    @property
    def indirect_links(self) -> "Optional[GrantaServerApiIndirectLinks]":
        """Gets the indirect_links of this GrantaServerApiSearchLinkDatumCriterion.

        Returns
        -------
        GrantaServerApiIndirectLinks
            The indirect_links of this GrantaServerApiSearchLinkDatumCriterion.
        """
        return self._indirect_links

    @indirect_links.setter
    def indirect_links(
        self, indirect_links: "Optional[GrantaServerApiIndirectLinks]"
    ) -> None:
        """Sets the indirect_links of this GrantaServerApiSearchLinkDatumCriterion.

        Parameters
        ----------
        indirect_links: GrantaServerApiIndirectLinks
            The indirect_links of this GrantaServerApiSearchLinkDatumCriterion.
        """
        self._indirect_links = indirect_links

    @property
    def search_in_reversed_direction(self) -> "Optional[bool]":
        """Gets the search_in_reversed_direction of this GrantaServerApiSearchLinkDatumCriterion.

        Returns
        -------
        bool
            The search_in_reversed_direction of this GrantaServerApiSearchLinkDatumCriterion.
        """
        return self._search_in_reversed_direction

    @search_in_reversed_direction.setter
    def search_in_reversed_direction(
        self, search_in_reversed_direction: "Optional[bool]"
    ) -> None:
        """Sets the search_in_reversed_direction of this GrantaServerApiSearchLinkDatumCriterion.

        Parameters
        ----------
        search_in_reversed_direction: bool
            The search_in_reversed_direction of this GrantaServerApiSearchLinkDatumCriterion.
        """
        self._search_in_reversed_direction = search_in_reversed_direction

    @property
    def target_attribute_identity(self) -> "Optional[int]":
        """Gets the target_attribute_identity of this GrantaServerApiSearchLinkDatumCriterion.
        For tabular searching: this is the identity of the short-text linking attribute.  The target attribute and table can both be omitted; it is likely to improve performance if they are included.  If either the target attribute or the target table is provided, they should both be provided.  Otherwise null.

        Returns
        -------
        int
            The target_attribute_identity of this GrantaServerApiSearchLinkDatumCriterion.
        """
        return self._target_attribute_identity

    @target_attribute_identity.setter
    def target_attribute_identity(
        self, target_attribute_identity: "Optional[int]"
    ) -> None:
        """Sets the target_attribute_identity of this GrantaServerApiSearchLinkDatumCriterion.
        For tabular searching: this is the identity of the short-text linking attribute.  The target attribute and table can both be omitted; it is likely to improve performance if they are included.  If either the target attribute or the target table is provided, they should both be provided.  Otherwise null.

        Parameters
        ----------
        target_attribute_identity: int
            The target_attribute_identity of this GrantaServerApiSearchLinkDatumCriterion.
        """
        self._target_attribute_identity = target_attribute_identity

    @property
    def target_attribute_guid(self) -> "Optional[str]":
        """Gets the target_attribute_guid of this GrantaServerApiSearchLinkDatumCriterion.
        For tabular searching: this is the GUID of the short-text linking attribute.  /// The target attribute and table can both be omitted; it is likely to improve performance if they are included.  If either the target attribute or the target table is provided, they should both be provided.  Otherwise null.

        Returns
        -------
        str
            The target_attribute_guid of this GrantaServerApiSearchLinkDatumCriterion.
        """
        return self._target_attribute_guid

    @target_attribute_guid.setter
    def target_attribute_guid(self, target_attribute_guid: "Optional[str]") -> None:
        """Sets the target_attribute_guid of this GrantaServerApiSearchLinkDatumCriterion.
        For tabular searching: this is the GUID of the short-text linking attribute.  /// The target attribute and table can both be omitted; it is likely to improve performance if they are included.  If either the target attribute or the target table is provided, they should both be provided.  Otherwise null.

        Parameters
        ----------
        target_attribute_guid: str
            The target_attribute_guid of this GrantaServerApiSearchLinkDatumCriterion.
        """
        self._target_attribute_guid = target_attribute_guid

    @property
    def inner_criterion(self) -> "Optional[GrantaServerApiSearchCriterion]":
        """Gets the inner_criterion of this GrantaServerApiSearchLinkDatumCriterion.

        Returns
        -------
        GrantaServerApiSearchCriterion
            The inner_criterion of this GrantaServerApiSearchLinkDatumCriterion.
        """
        return self._inner_criterion

    @inner_criterion.setter
    def inner_criterion(
        self, inner_criterion: "Optional[GrantaServerApiSearchCriterion]"
    ) -> None:
        """Sets the inner_criterion of this GrantaServerApiSearchLinkDatumCriterion.

        Parameters
        ----------
        inner_criterion: GrantaServerApiSearchCriterion
            The inner_criterion of this GrantaServerApiSearchLinkDatumCriterion.
        """
        self._inner_criterion = inner_criterion

    @property
    def type(self) -> "str":
        """Gets the type of this GrantaServerApiSearchLinkDatumCriterion.

        Returns
        -------
        str
            The type of this GrantaServerApiSearchLinkDatumCriterion.
        """
        return self._type

    @type.setter
    def type(self, type: "str") -> None:
        """Sets the type of this GrantaServerApiSearchLinkDatumCriterion.

        Parameters
        ----------
        type: str
            The type of this GrantaServerApiSearchLinkDatumCriterion.
        """
        if type is None:
            raise ValueError("Invalid value for 'type', must not be 'None'")
        self._type = type

    @property
    def local_rows_behaviour(
        self,
    ) -> "Optional[GrantaServerApiSearchLocalRowsBehaviour]":
        """Gets the local_rows_behaviour of this GrantaServerApiSearchLinkDatumCriterion.

        Returns
        -------
        GrantaServerApiSearchLocalRowsBehaviour
            The local_rows_behaviour of this GrantaServerApiSearchLinkDatumCriterion.
        """
        return self._local_rows_behaviour

    @local_rows_behaviour.setter
    def local_rows_behaviour(
        self, local_rows_behaviour: "Optional[GrantaServerApiSearchLocalRowsBehaviour]"
    ) -> None:
        """Sets the local_rows_behaviour of this GrantaServerApiSearchLinkDatumCriterion.

        Parameters
        ----------
        local_rows_behaviour: GrantaServerApiSearchLocalRowsBehaviour
            The local_rows_behaviour of this GrantaServerApiSearchLinkDatumCriterion.
        """
        self._local_rows_behaviour = local_rows_behaviour

    @classmethod
    def get_real_child_model(cls, data: ModelBase) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()  # type: ignore[no-any-return]

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, GrantaServerApiSearchLinkDatumCriterion):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
